//#include<iostream>

#include "fingertech.h"
#define DLLEXPORT extern "C" __declspec(dllexport)

int main(int argc,char *argv[]){

	for(int i = 0; i<argc; i++){
		cout << "Parametro:" << argv[i] << endl;
    }
	Fingertech objFingertech(1);
	objFingertech.InitNBSPSDK();
    NBioAPI_RETURN nRet = objFingertech.SetDeviceList();
	if (NBioAPIERROR_NONE != nRet){
		cout << "Erro na funcao: SetDeviceList - " << nRet << endl;
		return 0;
	}

    cout << "eNBSP SDK Initialize Success!" << endl;

	switch (atoi(argv[1])){
		case 1:
		    // grava a biometria no arquivo passado como segundo parametro de 'Grava_fir'
            nRet = objFingertech.OpenDevice();
            if (NBioAPIERROR_NONE != nRet){
                cout << "Erro na funcao: OpenDevice() - " << nRet << endl;
                return 0;
                }
            cout << "Open Device API Success!" << endl;

            objFingertech.Grava_fir(atoi(argv[2]), argv[3], argv[4]);
		    break;

		case 2:
		    // Compara a digital gravada no arquvo gerado no case 4 com a digital que sera lida
            nRet = objFingertech.OpenDevice();
            if (NBioAPIERROR_NONE != nRet){
                cout << "Erro na funcao: OpenDevice() - " << nRet << endl;
                return 0;
            }
            cout << "Open Device API Success!" << endl;
            objFingertech.Compara_fir_gravado(atoi(argv[2]), argv[3], argv[4]);
		    break;

		case 3:
		    // Pega a biometria passada como parametro e compara com a biometria que sera lida
            nRet = objFingertech.OpenDevice();
            if (NBioAPIERROR_NONE != nRet){
                cout << "Erro na funcao: OpenDevice() - " << nRet << endl;
                return 0;
            }
            cout << "Open Device API Success!" << endl;
            objFingertech.Compara_dois_fir(argv[2], argv[3], argv[4]);
		    break;

		case 4:
		    // Pega a biometria passada como parametro e compara com a biometria que sera lida
            nRet = objFingertech.OpenDevice();
            if (NBioAPIERROR_NONE != nRet){
                cout << "Erro na funcao: OpenDevice() - " << nRet << endl;
                return 0;
            }

            cout << "Open Device API Success!" << endl;
		    objFingertech.Checa_dedo_no_leitor(argv[2]);
		    break;

		case 5:
		    // Compara varias biometrias com uma lida
            nRet = objFingertech.OpenDevice();
            if (NBioAPIERROR_NONE != nRet){
                cout << "Erro na funcao: OpenDevice() - " << nRet << endl;
                return 0;
            }
            cout << "Open Device API Success!" << endl;
            objFingertech.Compara_varios_fir(atoi(argv[2]), argv[3], argv[4]);
		    break;

		case 6:
		    // registra digital na NBio usa banco de dados virtual
		    objFingertech.Registra_Digital(atoi(argv[2]));
		    break;
		case 7:
		    // Usa banco de dados virtual
            objFingertech.Identifica_Digital();
		    break;
		case 8:
		    // caso de teste, ler duas digitais seguidas e compara se sao iguais
            nRet = objFingertech.OpenDevice();
            if (NBioAPIERROR_NONE != nRet)
                cout << "Erro ao abrir: " << nRet << endl;
            else
                cout << "Open Device API Success!" << endl;

            NBioAPI_RETURN Fir1 = objFingertech.Capture(10000);
            cout << "Fir1: " << Fir1 << endl;
		    break;
	}
    objFingertech.TerminateNBSPSDK();
	return 0;


}

Fingertech::Fingertech()
{

} // Fim de Fingertech::Fingertech()
Fingertech::Fingertech(int i)
{

}
Fingertech::~Fingertech()
{
        cout << "\nDestruindo Fingertech..." << endl;
} // Fim de Fingertech::~Fingertech()


NBioAPI_RETURN Fingertech::MyCallBackFun(NBioAPI_INDEXSEARCH_CALLBACK_PARAM_PTR_0 pCallbackParam0)
{


    if (m_bStopFlag)
        return NBioAPI_INDEXSEARCH_CALLBACK_STOP;

    return NBioAPI_INDEXSEARCH_CALLBACK_OK;
}

NBioAPI_RETURN MyIndexSearchCallBack(NBioAPI_INDEXSEARCH_CALLBACK_PARAM_PTR_0 pCallbackParam0, NBioAPI_VOID_PTR pUserParam)
{
    Fingertech* pDlg = (Fingertech*) pUserParam;

    return pDlg->MyCallBackFun(pCallbackParam0);
}

void Fingertech::InitNBSPSDK()
{
    // NBioBSP SDK module initialization.
    NBioAPI_RETURN nRet = NBioAPI_Init(&m_hNBioBSP);
    nRet = NBioAPI_InitIndexSearchEngine(m_hNBioBSP);

}

NBioAPI_RETURN Fingertech::SetDeviceList()
{
    NBioAPI_UINT32 nDeviceCnt;                  // Device Total Count
    NBioAPI_DEVICE_ID* pDeviceList;             // Device ID
    NBioAPI_DEVICE_INFO_EX_PTR pDeviceInfoEx;   // Device Information

    //NBioAPI Enumerate Device List
    NBioAPI_RETURN nRet = NBioAPI_EnumerateDeviceEx(m_hNBioBSP, &nDeviceCnt, &pDeviceList, &pDeviceInfoEx);
    if (NBioAPIERROR_NONE == nRet)  {
        NBioAPI_UINT32 i;
        NBioAPI_DEVICE_ID deviceID;

        for (i = 0; i < nDeviceCnt; i++)  {
            deviceID = pDeviceInfoEx[i].NameID | (pDeviceInfoEx[i].Instance << 8);
        }
    }
    return nRet;
}

NBioAPI_RETURN Fingertech::OpenDevice()
{
    NBioAPI_RETURN nRet;
    NBioAPI_DEVICE_ID deviceID = NBioAPI_GetOpenedDeviceID(m_hNBioBSP);  //Get Device ID
    //Close Before Module Device.
    if (NBioAPI_DEVICE_ID_NONE != deviceID)
        NBioAPI_CloseDevice(m_hNBioBSP, deviceID);

    deviceID = NBioAPI_DEVICE_ID_AUTO;

    //Open Device
    nRet = NBioAPI_OpenDevice(m_hNBioBSP, deviceID);
    cout << "NBioAPI_OpenDevice: " << nRet << endl;

    return nRet;
}

void Fingertech::TerminateNBSPSDK()
{
    //Free FIR Handle.
    if (m_hNBioBSP)  {
        NBioAPI_DEVICE_ID deviceID = NBioAPI_GetOpenedDeviceID(m_hNBioBSP);

        //Device Close.
        if (NBioAPI_DEVICE_ID_NONE != deviceID)
            NBioAPI_CloseDevice(m_hNBioBSP, deviceID);

        //NBioAPI Terminate
        NBioAPI_Terminate(m_hNBioBSP);
    }
}

void Fingertech::Checa_dedo_no_leitor(string dir_nome_log)
{
    NBioAPI_RETURN ret;
    NBioAPI_BOOL pbExistFinger;
//    NBioAPI_VERSION pVersion;
//    NBioAPI_GetVersion(m_hNBioBSP, &pVersion);
//    cout << "Versao: " << pVersion.Major << " | " << pVersion.Minor << endl;

    ret = NBioAPI_CheckFinger(m_hNBioBSP, &pbExistFinger);
    if (NBioAPIERROR_NONE == ret) {
        if (pbExistFinger)
            Grava_arquivo("3;Dedo posicionado no leitor", dir_nome_log);
        else
            Grava_arquivo("2;Leitor vazio", dir_nome_log);
    }
    else{
        Grava_arquivo("1;Erro na funcao NBioAPI_CheckFinger", dir_nome_log);
        cout << "Erro na funcao NBioAPI_CheckFinger: " << ret << endl;

        if (NBioAPIERROR_INVALID_HANDLE == ret)
            { cout << "Invalid NBioAPI handle." << endl;}
        if (NBioAPIERROR_DEVICE_NOT_OPENED == ret)
            { cout << "NBioAPIERROR_DEVICE_NOT_OPENED:" << endl;}
        if (NBioAPIERROR_LOWVERSION_DRIVER ==  ret)
            { cout << "NBioAPIERROR_LOWVERSION_DRIVER:" << endl;}
    }

}
NBioAPI_RETURN Fingertech::Grava_fir(int timeout, string dir_nome_arquivo, string dir_nome_log){
    /* Grava a leitura da digital em no arquivo passado no parametro
    :param timeout: numero de mili-segundos que o leitor ficara esperando pela deitura da biometria
    :param dir_nome_arquivo: diretorio concatenado com o nome do arquivo a ser gravado
                             ex: /tmp/teste.txt
    */
//    NBioAPI_FIR_HANDLE firHandle;
//    NBioAPI_FIR_PURPOSE purpose;
    NBioAPI_RETURN ret;
//    purpose = NBioAPI_FIR_PURPOSE_ENROLL;
//
//    cout << "Coloque o dedo no leitor: " << endl;
//    // Captura biometria
//    ret = NBioAPI_Capture(
//        m_hNBioBSP,   // Módulo para manusear módulo NBioBSP
//        purpose,     // Propósito da captura
//        &firHandle,  // Manipular o FIR capturado
//        timeout,     // Timeout para captura
//        NULL,        // Dados para auditoria
//        NULL         // Opção da janela
//    );
//    // Capturar FIR da digital e retornar o hash do template.
//    NBioAPI_FIR_TEXTENCODE textFIR;
//    if (NBioAPIERROR_NONE != ret)  {
//        cout << "NBioAPI_Capture error: " << ret << endl;
//
//        Grava_arquivo("1;Erro na captura da biometria", dir_nome_log);
//
//    }
//    else
//        Grava_arquivo("3;Biometria capturada com sucesso", dir_nome_log);
//
//    ret = NBioAPI_GetTextFIRFromHandle(m_hNBioBSP, firHandle, &textFIR, NBioAPI_FALSE);

    Export_Fir(timeout);
    Save_Exported(dir_nome_arquivo, dir_nome_log);

//    Grava_arquivo(textFIR.TextFIR, dir_nome_arquivo);

    return ret;
}

void Fingertech::Compara_fir_gravado(int timeout, string dir_nome_arquivo, string dir_nome_log){
    /* Le o arquivo passado pelo parametro 'dir_nome_arquivo' e compara se a biometria contida
       nele eh igual a biometria lida no dispositivo, se for igual grava o valor desejado no arquivo
       passado na funcao 'Grava_arquivo'
    :param timeout: numero de mili-segundos que o leitor ficara esperando pela deitura da biometria
    :param dir_nome_arquivo: diretorio concatenado com o nome do arquivo a ser gravado
                             ex: /tmp/teste.txt
    */
    NBioAPI_FIR_HANDLE firHandle;
    NBioAPI_FIR_PURPOSE purpose;
    NBioAPI_RETURN ret;
    purpose = NBioAPI_FIR_PURPOSE_ENROLL;
    m_pTemplate = NULL;

    cout << "Coloque o dedo no leitor: " << endl;
    // Captura biometria
    ret = NBioAPI_Capture(
        m_hNBioBSP,   // Módulo para manusear módulo NBioBSP
        purpose,     // Propósito da captura
        &firHandle,  // Manipular o FIR capturado
        timeout,     // Timeout para captura
        NULL,        // Dados para auditoria
        NULL         // Opção da janela
    );
    // Capturar FIR da digital e retornar o hash do template.
    NBioAPI_FIR_TEXTENCODE textFIR;
    ret = NBioAPI_GetTextFIRFromHandle(m_hNBioBSP, firHandle, &textFIR, NBioAPI_FALSE);
    Load_Imported(dir_nome_arquivo, dir_nome_log);
    Import_Fir();

    ret = Match(textFirImported.TextFIR, textFIR.TextFIR);

    if (ret){
	    cout << "Digitais Iguais!" << endl;
        Grava_arquivo("3;Digitais Iguais!", dir_nome_log);
    }
    else{
	    cout << "Digitais Diferentes!" << endl;
        Grava_arquivo("2;Digitais diferentes;", dir_nome_log);
	    }
}

void Fingertech::Compara_dois_fir(string textFIR1, string textFIR2, string dir_nome_log){
    /* Compara as duas biometrias passadas no parametro*/

    NBioAPI_RETURN ret;
    ret = Match(textFIR1, textFIR2);

    if (ret){
	    cout << "Digitais Iguais!" << endl;
        Grava_arquivo("3;Digitais Iguais!", dir_nome_log);
    }
    else{
	    cout << "Digitais Diferentes!" << endl;
        Grava_arquivo("2;Digital nao encontrada;", dir_nome_log);
	    }
}

void Fingertech::Adiciona_fir_bd(string line, int id_fir){
    NBioAPI_RETURN Ret;
    NBioAPI_FIR_HANDLE hProcessedFIR;
    m_nLen = line.size();
    m_pTemplate = new NBioAPI_UINT8[m_nLen];
    strncpy((char*) m_pTemplate, line.c_str(), m_nLen);

    if (m_pTemplate == NULL || m_nLen == 0)  {
        cout << "Load data file first." << endl;
        return;
    }

    //FDX data Convert FIR data
    Ret = NBioAPI_FDxToNBioBSP(m_hNBioBSP, m_pTemplate, m_nLen, MINCONV_TYPE_FDP, NBioAPI_FIR_PURPOSE_VERIFY, &hProcessedFIR);

    if (NBioAPIERROR_NONE == Ret)  {
        NBioAPI_BOOL bResult;
        inputFIR_imported.Form = NBioAPI_FIR_FORM_HANDLE;
        inputFIR_imported.InputFIR.FIRinBSP = &hProcessedFIR;
    }
    else
        if (Ret == NBioAPIERROR_INVALID_HANDLE)
            cout << "Invalid NBioAPI handle" << endl;
        if (Ret == NBioAPIERROR_INVALID_POINTER)
            cout <<  "Invalid parameter pointer." << endl;
        if (Ret == NBioAPIERROR_INVALID_MINSIZE)
            cout << "Invalid minutiae size." << endl;
        if (Ret == NBioAPIERROR_FUNCTION_FAIL)
            cout << "Function failed." << endl;

    NBioAPI_INDEXSEARCH_SAMPLE_INFO infoSample;         // Sample Finger Sample Information.
    Ret = NBioAPI_AddFIRToIndexSearchDB(m_hNBioBSP, &inputFIR_imported, id_fir, &infoSample);
    // Registrando o hash do template FIR no Input de FIR armazenado.
    if (NBioAPIERROR_NONE != Ret)
        cout << "Erro na funcao NBioAPI_AddFIRToIndexSearchDB: " << Ret << endl << endl;
    else
        cout << "Incluindo - id fir: " << id_fir << endl;

   // NBioAPI_FreeFIRHandle(m_hNBioBSP, hProcessedFIR);

}

void Fingertech::Compara_varios_fir(int timeout, string dir_firs, string dir_nome_log){
    NBioAPI_RETURN nRet;
    NBioAPI_FIR_HANDLE firHandle;
    m_pTemplate = NULL;

    // ------ Captura as strings dos fir no arquivo e popula o bd
    string line;
    string aux = "";
    string line_aux = "";
    int id_fir;
    ifstream myfile (dir_firs.c_str());
    if (myfile.is_open()){
        while ( getline (myfile,line) ){
            if (line[3] != ';'){
                // quando o fir quebra linha na leirta das linhas perde o \n, logo deve ser incluido
                line_aux += "\n" + line;
                continue;
            }
            else{
                aux = line[0];
                aux += line[1];
                aux += line[2];
                aux += line[3];
                string::size_type i = line.find(aux);
                if (i != string::npos)
                   line.erase(i, aux.length());

                if (line_aux == ""){
                    line_aux = line;
                    id_fir = atoi(aux.c_str());
                    continue;
                }
                else {
                    Adiciona_fir_bd(line_aux, id_fir);
                    line_aux = line;
                    id_fir = atoi(aux.c_str());
                }

            }
        }
        // insere o ultimo FIR do arquivo
        if (line_aux != ""){
            Adiciona_fir_bd(line_aux, id_fir);
        }

        myfile.close();
    }

    NBioAPI_SaveIndexSearchDBToFile(m_hNBioBSP, "/tmp/IndexSearch.ISDB");

    cout << "Coloque o dedo no leitor: " << endl;
    // Captura biometria
    nRet = NBioAPI_Capture(
        m_hNBioBSP,   // Módulo para manusear módulo NBioBSP
        NBioAPI_FIR_PURPOSE_VERIFY,     // Propósito da captura
        &firHandle,  // Manipular o FIR capturado
        timeout,     // Timeout para captura
        NULL,        // Dados para auditoria
        NULL         // Opção da janela
    );
    // Registrando o hash do template FIR no Input de FIR capturado.
    NBioAPI_INPUT_FIR inputFirCaptured;
    inputFirCaptured.Form = NBioAPI_FIR_FORM_HANDLE;
    inputFirCaptured.InputFIR.FIRinBSP = &firHandle;

    NBioAPI_INDEXSEARCH_FP_INFO infoFp;

    Grava_arquivo("2;Digital nao encontrada", dir_nome_log);
    nRet = NBioAPI_IdentifyDataFromIndexSearchDB(m_hNBioBSP, &inputFirCaptured, 5, &infoFp, NULL);
    if (NBioAPIERROR_NONE != nRet)  {
        if (NBioAPIERROR_INDEXSEARCH_IDENTIFY_STOP != nRet){
            cout << "Digital nao encontrada" << endl;
            Grava_arquivo("2;Digital nao encontrada", dir_nome_log);
            }
        if (NBioAPIERROR_INVALID_HANDLE == nRet)
            cout <<  "Invalid NBioAPI handle." << endl;
        if(NBioAPIERROR_INVALID_POINTER)
            cout <<  "Invalid parameter pointer." << endl;
        if(NBioAPIERROR_INDEXSEARCH_INIT_FAIL == nRet)
            cout <<  "IndexSearch engine not initialized." << endl;
        if(NBioAPIERROR_INDEXSEARCH_IDENTIFY_FAIL == nRet)
            cout <<  "Failed to find identical template." << endl;
        if(NBioAPIERROR_UNKNOWN_INPUTFORMAT == nRet)
            cout <<  "Known input format." << endl;
        if(NBioAPIERROR_UNKNOWN_FORMAT == nRet)
            cout << "Known format" << endl;
        if (NBioAPIERROR_INDEXSEARCH_IDENTIFY_STOP == nRet)
            cout << "Identification stopped by callback functions." << endl;

    }
    else{
        std::ostringstream ss;
        ss << infoFp.ID;
        cout << "Digital encontrada cod: " << infoFp.ID << endl;
        Grava_arquivo("3;" + ss.str() , dir_nome_log);
    }


    //Close Device.
    NBioAPI_CloseDevice(m_hNBioBSP, NBioAPI_DEVICE_ID_AUTO);
}

NBioAPI_RETURN Fingertech::Capture(int timeout){
    NBioAPI_FIR_HANDLE firHandle;
    NBioAPI_FIR_PURPOSE purpose;
    NBioAPI_RETURN ret;
    purpose = NBioAPI_FIR_PURPOSE_VERIFY;

    cout << "Coloque o dedo no leitor: " << endl;
    ret = NBioAPI_Capture(
        m_hNBioBSP,   // Módulo para manusear módulo NBioBSP
        purpose,     // Propósito da captura
        &firHandle,  // Manipular o FIR capturado
        timeout,     // Timeout para captura
        NULL,        // Dados para auditoria
        NULL         // Opção da janela
    );

    // Capturar FIR da digital e retornar o hash do template.
    NBioAPI_FIR_TEXTENCODE textFIR;
    ret = NBioAPI_GetTextFIRFromHandle(m_hNBioBSP, firHandle, &textFIR, NBioAPI_FALSE);
    cout << "Fir: " << textFIR.TextFIR << endl;


    sleep(3);
    cout << "Coloque o dedo novamente no leitor: " << endl;
    //cin >> a;
    ret = NBioAPI_Capture(
        m_hNBioBSP,   // Módulo para manusear módulo NBioBSP
        purpose,     // Propósito da captura
        &firHandle,  // Manipular o FIR capturado
        timeout,     // Timeout para captura
        NULL,        // Dados para auditoria
        NULL         // Opção da janela
    );

    // Capturar FIR da digital e retornar o hash do template.
    NBioAPI_FIR_TEXTENCODE textFIR2;
    ret = NBioAPI_GetTextFIRFromHandle(m_hNBioBSP, firHandle, &textFIR2, NBioAPI_FALSE);
    cout << "Fir: " << textFIR2.TextFIR << endl;
    ret = Match(textFIR.TextFIR, textFIR2.TextFIR);

    if (ret) {
	cout << "Digitais OK" << endl;
    }else{
	cout << "Digitais Diferentes" << endl;
    }

    return ret;
}


// Método para a realização de comparações de FIR templates.
bool Fingertech::Match(string firCaptured, string firStored){
    NBioAPI_BOOL result;
    NBioAPI_INPUT_FIR inputFirCaptured, inputFirStored;
    NBioAPI_RETURN ret;

    // Convertendo para string as FIRs do argumento do método.
    std::string valueFirCaptured(firCaptured);
    std::string valueFirStored(firStored);

    // Extraindo os tamanhos dos valores do template capturado e armazenado.
    int lenFirCaptured = strlen(valueFirCaptured.c_str());
    int lenFirStored = strlen(valueFirStored.c_str());

    // Extraindo o hash do template FIR capturado.
    NBioAPI_FIR_TEXTENCODE textFirCaptured;
    textFirCaptured.IsWideChar = NBioAPI_FALSE;
    textFirCaptured.TextFIR = new NBioAPI_CHAR[lenFirCaptured+1];
    memcpy(textFirCaptured.TextFIR, valueFirCaptured.c_str(), lenFirCaptured+1);

    // Registrando o hash do template FIR no Input de FIR capturado.
    inputFirCaptured.Form = NBioAPI_FIR_FORM_TEXTENCODE;
    inputFirCaptured.InputFIR.TextFIR = &textFirCaptured;

    // Extraindo o hash do template FIR armazenado.
    NBioAPI_FIR_TEXTENCODE textFirStored;
    textFirStored.IsWideChar = NBioAPI_FALSE;
    textFirStored.TextFIR = new NBioAPI_CHAR[lenFirStored+1];
    memcpy(textFirStored.TextFIR, valueFirStored.c_str(), lenFirStored+1);

    // Registrando o hash do template FIR no Input de FIR armazenado.
    inputFirStored.Form = NBioAPI_FIR_FORM_TEXTENCODE;
    inputFirStored.InputFIR.TextFIR = &textFirStored;

    // Fazer match das FIR e armazenar o resultado em result.
    ret = NBioAPI_VerifyMatch(
        m_hNBioBSP,      	// Manipulador do módulo NBioBSP
        &inputFirCaptured, 	// Primeira FIR
        &inputFirStored,  	// Segunda FIR
        &result,    		// Resultado da comparação
        NULL    			// Payload
    );

    if(result == NBioAPI_TRUE)
        return true;

    return false;
}

bool Fingertech::Registra_Digital(int user_id)
{
    int m_nUserID;
    bool erro = false;
    m_nUserID = user_id;
    // Open Device.
    NBioAPI_RETURN nRet = NBioAPI_OpenDevice(m_hNBioBSP, NBioAPI_DEVICE_ID_AUTO);

    if (NBioAPIERROR_NONE != nRet)  {
        erro = true;
        cout << "NBioAPI_OpenDevice error: " << nRet << endl;
        Grava_arquivo("NBioAPI_OpenDevice error", "/tmp/ctp.txt");
    }

    NBioAPI_FIR_HANDLE hFIR;
    // NBioAPI Enroll.
    nRet = NBioAPI_Capture(m_hNBioBSP, NBioAPI_FIR_PURPOSE_VERIFY, &hFIR, -1, NULL, NULL);

    if (NBioAPIERROR_NONE == nRet)  {
        NBioAPI_INPUT_FIR inputFIR;                         // Fir Data.
        NBioAPI_INDEXSEARCH_SAMPLE_INFO infoSample;         // Sample Finger Sample Information.

        inputFIR.Form = NBioAPI_FIR_FORM_HANDLE;
        inputFIR.InputFIR.FIRinBSP = &hFIR;

        // Search FIRDB about Template Information.
        cout << "ID: " << m_nUserID << endl;
        nRet = NBioAPI_AddFIRToIndexSearchDB(m_hNBioBSP, &inputFIR, m_nUserID, &infoSample);

        if (NBioAPIERROR_NONE != nRet)  {
            if (NBioAPIERROR_INVALID_HANDLE == nRet)
                { cout << "Invalid NBioAPI handle." << endl;}
            if (NBioAPIERROR_INVALID_POINTER == nRet)
                { cout << "Invalid parameter pointer." << endl;}
            if (NBioAPIERROR_INDEXSEARCH_INIT_FAIL ==  nRet)
                { cout << "IndexSearch engine not initialized." << endl;}
            if (NBioAPIERROR_UNKNOWN_INPUTFORMAT == nRet)
                { cout << "Known input format." << endl;}
            if (NBioAPIERROR_UNKNOWN_FORMAT ==  nRet)
                { cout << "Known format." << endl;}

            cout << "NBioAPI_AddFIRToIndexSearchDB error: " << nRet << endl;
            Grava_arquivo("NBioAPI_AddFIRToIndexSearchDB error", "/tmp/ctp.txt");
            erro = true;
        }
        //Free FIR Handle.
        NBioAPI_FreeFIRHandle(m_hNBioBSP, hFIR);
    }
    else  {
        cout << "NBioAPI_Capture error: " << nRet << endl;
        Grava_arquivo("NBioAPI_Capture error:", "/tmp/ctp.txt");
        erro = true;
    }

    if (!erro)
        Grava_arquivo("3;Digital registrada com sucesso!", "/tmp/ctp.txt");
    //Close Device.
    NBioAPI_CloseDevice(m_hNBioBSP, NBioAPI_DEVICE_ID_AUTO);
    NBioAPI_SaveIndexSearchDBToFile(m_hNBioBSP, "/tmp/IndexSearch.ISDB");

    return true;

}


bool Fingertech::Identifica_Digital()
{
    bool erro = false;
    NBioAPI_RETURN nRet;
    ifstream obj("/tmp/IndexSearch.ISDB");
    if (obj){
        nRet = NBioAPI_LoadIndexSearchDBFromFile(m_hNBioBSP, "/tmp/IndexSearch.ISDB");
        if (NBioAPIERROR_NONE != nRet)
            cout << "NBioAPI_LoadIndexSearchDBFromFile error: " << nRet << endl;
            erro = true;
    }
    NBioAPI_UINT32 nDataCount = 0;

    //NBioAPI Search DB Count.
    NBioAPI_GetDataCountFromIndexSearchDB(m_hNBioBSP, &nDataCount);
    m_bStopFlag = false;

    nRet = NBioAPI_OpenDevice(m_hNBioBSP, NBioAPI_DEVICE_ID_AUTO);

    if (NBioAPIERROR_NONE != nRet)  {
        cout << "NBioAPI_OpenDevice error: " << nRet << endl;
        erro = true;
    }
    else  {
        NBioAPI_FIR_HANDLE hFIR;

        //NBioAPI Capture
        nRet = NBioAPI_Capture(m_hNBioBSP, NBioAPI_FIR_PURPOSE_IDENTIFY, &hFIR, NBioAPI_USE_DEFAULT_TIMEOUT, NULL, NULL);

        if (NBioAPIERROR_NONE == nRet)  {
            NBioAPI_INPUT_FIR inputFIR;

            inputFIR.Form = NBioAPI_FIR_FORM_HANDLE;
            inputFIR.InputFIR.FIRinBSP = &hFIR;

            NBioAPI_INDEXSEARCH_FP_INFO infoFp;
            NBioAPI_INDEXSEARCH_CALLBACK_INFO_0 callbackInfo0;

            callbackInfo0.CallBackType = 0;
            callbackInfo0.CallBackFunction = MyIndexSearchCallBack;
            callbackInfo0.UserCallBackParam = this;

            //Search DB
            nRet = NBioAPI_IdentifyDataFromIndexSearchDB(m_hNBioBSP, &inputFIR, 5, &infoFp, &callbackInfo0);

            if (NBioAPIERROR_NONE != nRet)  {
                if (NBioAPIERROR_INDEXSEARCH_IDENTIFY_STOP != nRet)
                    cout << "NBioBSP_IndexSearch Digital nao encontrada: " << nRet << endl;
                    Grava_arquivo("2;Digital nao encontrada;", "/tmp/ctp.txt");
            }
            else  {
                cout << "Digital encontrada" << endl;
                Grava_arquivo("3;Digital encontrada;", "/tmp/ctp.txt");

            }
        }
        NBioAPI_FreeFIRHandle(m_hNBioBSP, hFIR);
        NBioAPI_CloseDevice(m_hNBioBSP, NBioAPI_DEVICE_ID_AUTO);
        return erro;
    }
}


void Fingertech::Export_Fir(int timeout)
{   /*
    Exporta a biometria(fir) lida para o formato FDP
    */
    NBioAPI_FIR_HANDLE hCaptured;

    memset(&m_ExportData, 0, sizeof(NBioAPI_EXPORT_DATA));
    //NBioAPI Capture.
    NBioAPI_RETURN nRet;
    nRet = NBioAPI_Capture(m_hNBioBSP, NBioAPI_FIR_PURPOSE_VERIFY, &hCaptured, timeout, NULL, NULL);

    if (NBioAPIERROR_NONE == nRet)  {
        NBioAPI_INPUT_FIR inputFIR;	//FIR Information.

        cout << "m_ExportData.FingerNum: " << m_ExportData.FingerNum << endl;
        if (m_ExportData.FingerNum > 0)
            NBioAPI_FreeExportData(m_hNBioBSP, &m_ExportData);

        memset(&m_ExportData, 0, sizeof(NBioAPI_EXPORT_DATA));

        inputFIR.Form = NBioAPI_FIR_FORM_HANDLE;
        inputFIR.InputFIR.FIRinBSP = &hCaptured;

        //FIR Data Convert to FDX Data
        nRet = NBioAPI_NBioBSPToFDx(m_hNBioBSP, &inputFIR, &m_ExportData, MINCONV_TYPE_FDP);

        if (NBioAPIERROR_NONE == nRet)  {
            cout << "NBioAPI_NBioBSPToFDx success" << endl;
        }
        else
            cout << "Erro na funcao NBioAPI_NBioBSPToFDx: " << nRet << endl;

        //FIR Handle Free
        NBioAPI_FreeFIRHandle(m_hNBioBSP, hCaptured);
    }
    else
        cout << "Erro na funcao NBioAPI_Capture: " << nRet << endl;

    // Close Device.
    NBioAPI_CloseDevice(m_hNBioBSP, NBioAPI_DEVICE_ID_AUTO);
}

void Fingertech::Save_Exported(string arq_biometria, string arq_log)
{
    if (m_ExportData.FingerNum > 0)  {
        FILE* fp;
        fp = fopen(arq_biometria.c_str(), "wb");
        if (fp)  {
            fwrite(m_ExportData.FingerData2[0].Template[0].Data, m_ExportData.FingerData2[0].Template[0].Length, 1, fp);
            fclose(fp);
            cout << "Success to save data" << endl;
            Grava_arquivo("3;Digital salva", arq_log);
        }
        else{
            cout << "Failed to save data" << endl;
            Grava_arquivo("1;Erro ao salvar o arqivo da biometria", arq_log);
        }
    }
    else{
        cout << "Can not find export data!!" << endl;
        Grava_arquivo("1;Nenhuma biometria para ser exportada", arq_log);
        }
}

void Fingertech::Load_Imported(string arq_biometria, string arq_log)
{
    FILE* fp;
    fp = fopen(arq_biometria.c_str(), "rb");
    if (fp)  {
        fseek(fp, 0L, SEEK_END);
        m_nLen = ftell(fp);
        fseek(fp, 0L, SEEK_SET);

        if (m_pTemplate)
            delete[] m_pTemplate;

        m_pTemplate = new NBioAPI_UINT8[m_nLen];

        fread(m_pTemplate, m_nLen, 1, fp);
        fclose(fp);
        cout << "Load success!" << endl;
    }
    else
        cout << "File open failed" << endl;
}


void Fingertech::Import_Fir()
{
    if (m_pTemplate == NULL || m_nLen == 0)  {
        cout << "Load data file first." << endl;
        return;
    }
    NBioAPI_FIR_HANDLE hProcessedFIR;

    //FDX data Convert FIR data
    NBioAPI_RETURN nRet = NBioAPI_FDxToNBioBSP(m_hNBioBSP, m_pTemplate, m_nLen, MINCONV_TYPE_FDP, NBioAPI_FIR_PURPOSE_VERIFY, &hProcessedFIR);

    if (NBioAPIERROR_NONE == nRet)  {
        NBioAPI_BOOL bResult;
        // Registrando o hash do template FIR no Input de FIR armazenado.
        nRet = NBioAPI_GetTextFIRFromHandle(m_hNBioBSP, hProcessedFIR, &textFirImported, NBioAPI_FALSE);
//        inputFIR_imported.Form = NBioAPI_FIR_FORM_TEXTENCODE;
//        inputFIR_imported.InputFIR.TextFIR = &textFirStored;
    }
    else
        cout << "Erro na funcao NBioAPI_FDxToNBioBSP: " << nRet << endl;

}


void Fingertech::Grava_arquivo(string text, string dir_nome_arquivo){
    ofstream myfile;
    myfile.open (dir_nome_arquivo.c_str());
    myfile << text;
    myfile.close();
}

string Fingertech::Ler_arquivo(string dir_nome_arquivo){
    string line;
    string texto = "";
    ifstream myfile (dir_nome_arquivo.c_str());
    if (myfile.is_open())
    {
        while ( getline (myfile,line) )
            {
                texto += line;
            }
        myfile.close();
    }
    return texto;
}