
__Autor__ = "Luiz Fernando"
__Empresa__ = "Sig Informatica Ltda"
__Site__ = "http://www.siginformatica.com.br"
__Versao__ = "1.01"
__DataAlteracao__ = "24/10/2008"
import sys, re

if __name__ == '__main__':
    try:
        if sys.argv[1] == '-9':
            print(('pis.py\t\t\tVersao:' + __Versao__ + '\tData:'+ __DataAlteracao__) +
                  '\tValidacao e formatacao de numeros de PIS')
        else:
            print(('\n\npis.py - Validacao e formatacao de numeros de PIS \n' + 'Versao: ' +
                   __Versao__ + '\n' + 'Data: '+ __DataAlteracao__ + '\n'))
    except:
        print(('\n\npis.py - Validacao e formatacao de numeros de PIS \n' + 'Versao: '+ __Versao__ +
              '\n' + 'Data: '+ __DataAlteracao__ + '\n'))

class Pis:
    """
    Classe para testar numeros de PIS
    """
    def __init__( self ):
        pass

    def verificarTamanho(self, pis):
        valor = re.sub('[^0-9]', '', pis)
        while len(valor) > 11:
            if valor[0] == '0':
                valor = valor[1:]
            else:
                break
        if len(valor) > 11:
            return False
        valor = str('{:0>11}'.format(valor))
        return valor

    def getDigito(self, pis):
        valor = self.verificarTamanho(pis)
        if not valor:
            return valor

        nmr = [
            int(valor[0]) * 3,
            int(valor[1]) * 2,
            int(valor[2]) * 9,
            int(valor[3]) * 8,
            int(valor[4]) * 7,
            int(valor[5]) * 6,
            int(valor[6]) * 5,
            int(valor[7]) * 4,
            int(valor[8]) * 3,
            int(valor[9]) * 2,
        ]

        digito = int(valor[10])

        # soma lista nmr
        total = sum(nmr)

        # calcula o resto da divisao da lista nmr por 11
        resto = total % 11

        # encontra o digito verificador
        dv = 11 - resto

        if dv in [10, 11]:
            dv = 0
        return dv

    def validate( self, pis):
        """
        Metodo para validar numeros de PIS
        """
        valor = self.verificarTamanho(pis)
        if not valor:
            return valor

        digito = int(valor[-1:])
        dv = self.getDigito(valor)

        return dv == digito

    def getFormatado(self, pis):
        valor = self.verificarTamanho(pis)
        if not valor:
            return valor
        formatado = '{}.{}.{}-{}'.format(valor[:3],valor[3:8],valor[8:10],valor[10:])
        return formatado

